# Class StandardMetadataTree

Object
Node
Parent
Region
Control
TreeTableView<TreeTable.Node>
MetadataTree
StandardMetadataTree

All Implemented Interfaces:
  `Styleable`, `EventTarget`, `Skinnable`

public class StandardMetadataTree extends MetadataTree
A view of `Metadata` properties organized as a tree table. The content of each row in this tree table is represented by a `TreeTable​.Node`. The tree table shows the following columns:

- `TableColumn​.NAME` — a name for the metadata property, e.g. "Title".
- `TableColumn​.VALUE` — the property value typically as a string, number or date.

This class still supports the `MetadataTree​.setContent(TreeTable)` method, but `setContent(Metadata)` should be used instead.

## Limitations

- The `rootProperty` should be considered read-only. For changing content, use the `MetadataTree​.contentProperty` instead.

Since:
  1.1
"TODO:"
  Add contextual menu for showing a node in the summary pane (we would store in memory the path, including sequence number for multi-values property, and apply it to all opened resources).

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class TreeTableView

  `TreeTableView​.EditEvent<S>, TreeTableView​.ResizeFeatures<S>, TreeTableView​.TreeTableViewFocusModel<S>, TreeTableView​.TreeTableViewSelectionModel<S>`

- ## Property Summary

  ### Properties inherited from class TreeTableView

  `columnResizePolicy, comparator, editable, editingCell, expandedItemCount, fixedCellSize, focusModel, onScrollToColumn, onScrollTo, onSort, placeholder, root, rowFactory, selectionModel, showRoot, sortMode, sortPolicy, tableMenuButtonVisible, treeColumn`

  ### Properties inherited from class Control

  `contextMenu, skin, tooltip`

  ### Properties inherited from class Region

  `background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

  ### Properties inherited from class Parent

  `needsLayout`

  ### Properties inherited from class Node

  `accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, focusVisible, focusWithin, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

- ## Field Summary

  ### Fields inherited from class MetadataTree

  `contentProperty`

  ### Fields inherited from class TreeTableView

  `CONSTRAINED_RESIZE_POLICY, CONSTRAINED_RESIZE_POLICY_ALL_COLUMNS, CONSTRAINED_RESIZE_POLICY_FLEX_LAST_COLUMN, CONSTRAINED_RESIZE_POLICY_FLEX_NEXT_COLUMN, CONSTRAINED_RESIZE_POLICY_LAST_COLUMN, CONSTRAINED_RESIZE_POLICY_NEXT_COLUMN, CONSTRAINED_RESIZE_POLICY_SUBSEQUENT_COLUMNS, DEFAULT_SORT_POLICY, UNCONSTRAINED_RESIZE_POLICY`

  ### Fields inherited from class Region

  `USE_COMPUTED_SIZE, USE_PREF_SIZE`

  ### Fields inherited from class Node

  `BASELINE_OFFSET_SAME_AS_HEIGHT`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `StandardMetadataTree()`
  Creates a new initially empty metadata tree.
  `StandardMetadataTree(MetadataSummary controller)`
  Creates a new initially empty metadata tree which will be automatically updated when the given widget shows new metadata.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setContent(Metadata metadata)`
  Sets the metadata to show in this tree table.

  ### Methods inherited from class MetadataTree

  `getContent, setContent`

  ### Methods inherited from class TreeTableView

  `columnResizePolicyProperty, comparatorProperty, createDefaultSkin, edit, editableProperty, editAnyEvent, editCancelEvent, editCommitEvent, editingCellProperty, editStartEvent, expandedItemCountProperty, fixedCellSizeProperty, focusModelProperty, getClassCssMetaData, getColumnResizePolicy, getColumns, getComparator, getControlCssMetaData, getEditingCell, getExpandedItemCount, getFixedCellSize, getFocusModel, getNodeLevel, getOnScrollTo, getOnScrollToColumn, getOnSort, getPlaceholder, getRoot, getRow, getRowFactory, getSelectionModel, getSortMode, getSortOrder, getSortPolicy, getTreeColumn, getTreeItem, getTreeItemLevel, getVisibleLeafColumn, getVisibleLeafColumns, getVisibleLeafIndex, isEditable, isShowRoot, isTableMenuButtonVisible, layoutChildren, onScrollToColumnProperty, onScrollToProperty, onSortProperty, placeholderProperty, queryAccessibleAttribute, refresh, resizeColumn, rootProperty, rowFactoryProperty, scrollTo, scrollToColumn, scrollToColumnIndex, selectionModelProperty, setColumnResizePolicy, setEditable, setFixedCellSize, setFocusModel, setOnScrollTo, setOnScrollToColumn, setOnSort, setPlaceholder, setRoot, setRowFactory, setSelectionModel, setShowRoot, setSortMode, setSortPolicy, setTableMenuButtonVisible, setTreeColumn, showRootProperty, sort, sortModeProperty, sortPolicyProperty, tableMenuButtonVisibleProperty, treeColumnProperty`

  ### Methods inherited from class Control

  `computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, executeAccessibleAction, getBaselineOffset, getContextMenu, getCssMetaData, getInitialFocusTraversable, getSkin, getTooltip, isResizable, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

  ### Methods inherited from class Region

  `backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

  ### Methods inherited from class Parent

  `getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

  ### Methods inherited from class Node

  `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, focusVisibleProperty, focusWithinProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getContentBias, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isFocusVisible, isFocusWithin, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, requestFocusTraversal, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Styleable

  `getStyleableNode`

- ## Constructor Details

  - ### StandardMetadataTree

    public StandardMetadataTree()
    Creates a new initially empty metadata tree.

  - ### StandardMetadataTree

    public StandardMetadataTree(MetadataSummary controller)
    Creates a new initially empty metadata tree which will be automatically updated when the given widget shows new metadata. This constructor registers a listener to `MetadataSummary​.metadataProperty` which forwards the metadata changes to `setContent(Metadata)`.
    Parameters:
      `controller` - the widget to watch, or `null` if none.

- ## Method Details

  - ### setContent

    public void setContent(Metadata metadata)
    Sets the metadata to show in this tree table. This method gets a `TreeTable` view of the given metadata, then delegates to `MetadataTree​.setContent(TreeTable)`.
    Parameters:
      `metadata` - the metadata to show in this tree table view, or `null` if none.